/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//				 
//				http://www.interestprograms.ru
//				    ,  ,  
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////



#include "StdAfx.h"
#include ".\mylabel.h"
//#include "util.h"
#include "mylabel.h"


//   :      - 
//          ,
// ,          
void AppProcessMessage(void)
{
	MSG message;
	if(::PeekMessage(&message, NULL, 0, 0, PM_REMOVE))
	{
		::TranslateMessage(&message);
		::DispatchMessage(&message);
	}	
}



CMyLabel::CMyLabel(void)
: m_Caption(_T(""))
, m_pParent(NULL)
, m_bCenter(false)
, m_X(0)
, m_Y(0)
, m_bShade(false)
, m_Width_Font(0)
, m_bRGN(false)
, m_bVisible(true)
{
	m_Rect.left = 0;
	m_Rect.top  = 0;
	m_ColorText  = RGB(0,0,0);
	m_ColorShade = RGB(0,0,0);

	m_RectRGN.SetRectEmpty();
	m_Font.CreatePointFont(110, "Arial");
}


//        CMyLabel ( )
//       
CMyLabel::CMyLabel(CWnd* pParent)
{
	m_pParent = pParent;
	CMyLabel();
}


//       
//        
void CMyLabel::SetParent(CWnd* pParent)
{
	m_pParent = pParent;
}

CMyLabel::~CMyLabel(void)
{
	if(m_Font.m_hObject != NULL)
		m_Font.DeleteObject();
}


//     
bool CMyLabel::SetCaption(const CString& caption, const int& effect)
{
	DWORD start;
	int size; 

	//    
	//    
	LOGFONT logfont;
	CFont* pFont = NULL;
	pFont = GetMyLabelFont();
	pFont->GetLogFont(&logfont);
	long height_font = logfont.lfHeight;
	long weight_font = logfont.lfWeight;
	long temp_width_font = m_Width_Font;


	//      ,
	//     
	if(height_font < 0)
		height_font *= -1;


	int temp_height, temp_top;
	switch(effect)
	{
	case 1: // --     --

		for(int i = temp_width_font; i >= 1; i--)
		{
			//    
			start = GetTickCount();
		
			//   
			SetMyLabelFont(height_font, weight_font, logfont.lfFaceName, i);
			
			//  15    
			//  " "    
			//     
			while( (GetTickCount() - start) < 15){AppProcessMessage();}
		}

		//      ,
		//    
		m_Caption = caption;
		

		//  ()  
		for(int ii = 1; ii <= temp_width_font; ii++)
		{
			start = GetTickCount();
			SetMyLabelFont(height_font, weight_font, logfont.lfFaceName, ii);
			
			while( (GetTickCount() - start) < 15){AppProcessMessage();}
		}
		
		break;

	case 2:// --          --

		//   ,     
		for(int i = height_font; i >= 1; i--)
		{
			start = GetTickCount();
			SetMyLabelFont( i, weight_font, logfont.lfFaceName);
			
			while( (GetTickCount() - start) < 15){AppProcessMessage();}
		}

		//      
		m_Caption = caption;
		
		//     
		for(int ii = 1; ii <= height_font; ii++)
		{
			start = GetTickCount();
			SetMyLabelFont( ii, weight_font, logfont.lfFaceName);
			
			while( (GetTickCount() - start) < 15){AppProcessMessage();}
		}
		
		
		break;
	case 3: // --       --

		//     

		//    
		temp_height = (m_Rect.bottom + 5);

		//     
		temp_top =  m_Rect.top;

		//   m_RectRGN 
		m_bRGN = true;
		

		//       
		for(int i = temp_top; i <= temp_height; i++)
		{
			//    
			start = GetTickCount();
		
			//    
			//     
			m_RectRGN.SetRect(m_Rect.left, m_Rect.top, m_Rect.right + 5, i);
			Invalidate();
			
			while( (GetTickCount() - start) < 15){AppProcessMessage();}
		}
		
		//  
		m_Caption = caption;

		//     
		Invalidate();

		//      
		//  
		for(int i = temp_top; i <= temp_height; i++)
		{
			start = GetTickCount();
		

			m_RectRGN.SetRect(m_Rect.left, i, m_Rect.right + 5, temp_height);
			Invalidate();
			
			while( (GetTickCount() - start) < 15){AppProcessMessage();}
		}

		//    
		//       
		m_bRGN = false;
	
		break;

	case 4: // --        -- 

		//      
		size = m_Caption.GetLength();

		//           
		//      
		for(int i = 0; i < size; i++)
		{
			start = GetTickCount();
	
			//    
			m_Caption.Delete(m_Caption.GetLength()-1);

			Invalidate();
			while( (GetTickCount() - start) < 25){AppProcessMessage();}
		}
	
		
		//      
		size = caption.GetLength();

		//         
		for(int j = 0; j < size; j++)
		{
			start = GetTickCount();
		
			//       
			m_Caption.AppendChar( caption[j]);
			Invalidate();

			while( (GetTickCount() - start) < 25){AppProcessMessage();}
		}
		break;

	default: // --    --
		m_Caption = caption;
		Invalidate();
		break;

	}
	
	//    
	//       ,     
	//  
	return true;
}


//   
CString CMyLabel::GetCaption(void)
{
	return m_Caption;
}


//      
//  "" 
void CMyLabel::Invalidate(void)
{
	ASSERT(m_pParent != NULL);

	if(m_pParent == NULL)
		return;
	
	//     
	//       
	CDC* pDC = m_pParent->GetDC();
	CRect rc;
	
	if(pDC != NULL){

		//          
		if(m_bShade == true)  rc.SetRect(m_Rect.left, m_Rect.top, m_Rect.right+5, m_Rect.bottom+5);
		else                  rc.SetRect(m_Rect.left, m_Rect.top, m_Rect.right, m_Rect.bottom);

		//   
		CFont* pOldFont = pDC->SelectObject(&m_Font); //   
		
		CSize cs = pDC->GetTextExtent(m_Caption);

		//           "W"
		int width_char  = pDC->GetTextExtent("W").cx;
		int width_text  = cs.cx;
		int height_text = cs.cy;
		if(m_bCenter == false) m_Rect.left = m_X;
		else				   m_Rect.left = m_X - width_text/2;
		m_Rect.top  = m_Y;
		m_Rect.right  = m_Rect.left + width_text;
		m_Rect.bottom = m_Rect.top  + height_text;

		//    ,     
		//    
		TEXTMETRIC m;
		pDC->GetTextMetrics(&m);
		
		m_Width_Font = 0;
		if(m_Caption.GetLength() != 0)
			m_Width_Font = m.tmAveCharWidth;

		//      
		pDC->SelectObject(pOldFont);
		//       
		//  
		m_pParent->ReleaseDC(pDC);

		//    width_char       
		//       ,
		//  ,    
		rc.left   = min(rc.left, m_Rect.left)   - width_char;
		rc.top    = min(rc.top, m_Rect.top);
		rc.right  = max(rc.right, m_Rect.right) + width_char;
		rc.bottom = max(rc.bottom, m_Rect.bottom);

		//    
		m_pParent->InvalidateRect(&rc);
	}
}


//   ,     
void CMyLabel::SetDC(CDC* pDC)
{
	//    ,       (   )
	ASSERT(m_pParent != NULL);

	if(m_pParent == NULL)
		return;

	//    
	// m_bVisible   Show()
	if(m_bVisible == false) return;

	//       
	//  .    ,    
	if(m_bRGN == true)
	{
		pDC->BeginPath();
		pDC->Rectangle( &m_RectRGN );
		
		//pDC->FillRect(&m_RectRGN, &CBrush(RGB(255,255,20))); //   
		
		pDC->EndPath();
		//pDC->FillPath();
		//  RGN_DIFF      
		// ,      BeginPath()  EndPath() 
		//       .  ""  
		//  ,       
		pDC->SelectClipPath(RGN_DIFF); //
	}


	//        
	int save = pDC->SaveDC();
	CFont* pOldFont = pDC->SelectObject(&m_Font);
	pDC->SetBkMode(TRANSPARENT);
	

	//     ?
	if(m_bShade == true)
	{
		pDC->SetTextColor(m_ColorShade);
		//           
		pDC->TextOut(m_Rect.left+5, m_Rect.top+5, m_Caption);
	}

	pDC->SetTextColor(m_ColorText);
	pDC->TextOut(m_Rect.left, m_Rect.top, m_Caption);
	
	//   
	pDC->SelectObject(pOldFont);
	pDC->RestoreDC(save);
}

//  ,     
//  center == true      
void CMyLabel::SetMyLabelPos(const CPoint& point, bool center)
{
	m_bCenter = center;
	m_X = point.x;
	m_Y = point.y;
	//        
	//     
	if(center == false) m_Rect.left = m_X;
	else				m_Rect.left = m_X - m_Rect.Width()/2;
	m_Rect.top  = m_Y;

	//     ,       
	m_RectRGN.SetRect(m_Rect.left, m_Rect.top, m_Rect.right + 5, m_Rect.bottom + 5);
	Invalidate();
}

void CMyLabel::SetMyLabelPos(const int& x, const int& y, bool center)
{
	SetMyLabelPos( CPoint(x,y), center);
}

//       ?
CPoint CMyLabel::GetMyLabelPos(void)
{
	return CPoint(m_Rect.left, m_Rect.top) ;
}


//    
void CMyLabel::SetColorText(COLORREF color)
{
	m_ColorText = color;
	Invalidate();
}


//          
void CMyLabel::SetMyLabelFont(const long& height, const long& weight, const CString& fontname, const long& width)
{
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT)); // 
	lf.lfHeight = height;  
	lf.lfWeight = weight;
	lf.lfWidth = width;
	lf.lfCharSet = RUSSIAN_CHARSET;
	strcpy(lf.lfFaceName, fontname);
	if(m_Font.m_hObject != NULL)
		m_Font.DeleteObject();
	VERIFY(m_Font.CreateFontIndirect(&lf)); 
	Invalidate();

	
}

//        
void CMyLabel::SetMyLabelFont(LOGFONT* logfont)
{
	if(m_Font.m_hObject != NULL)
		m_Font.DeleteObject();
	VERIFY(m_Font.CreateFontIndirect(logfont)); 
	Invalidate();
}



//
CFont* CMyLabel::GetMyLabelFont(void)
{
	return &m_Font;
}


//     
void CMyLabel::SetShade(bool shade)
{
	m_bShade = shade;
	Invalidate();
}


//         CMyLabel
bool CMyLabel::IsValid(void) const
{
	if(m_pParent == NULL)
		return false;

	return true;
}


//    
void CMyLabel::Show(bool show)
{
	m_bVisible = show;
	Invalidate();
}
